Subject: [lemonade] request for invocation of RFC 3683

From: Mark Crispin <[email-masked]>
Date: Thu, 18 Aug 2005 16:04:21 -0700 (PDT)

In light of the message below, I request that RFC 3683 be invoked.

-- Mark --

http://staff.washington.edu/mrc
Science does not emerge from voting, party politics, or public debate.
Si vis pacem, para bellum.

---------- Forwarded message ----------
Date: Thu, 18 Aug 2005 14:48:03 -0700
From: Marc Perkel <[email-masked]>
To: [email-masked]
Subject: Re: [lemonade] Outside the box suggestion about Lemonade

Mark Crispin wrote:

> On Thu, 18 Aug 2005, Marc Perkel wrote:
> 
>> It's an option. If you don't like it - don't implement it.
> 
> 
> Until some cretin makes the option mandatory in his client, and then posts on 
> his support page that the reason my server doesn't work with his client is 
> that my server is broken.

If it isn't lisdted in the CAPABILITIES then the client won't try to use it. 
There are a lot of things your IMAP server doesn't support.

> 
> This has happened before, and a steep price was paid each time.
> 
>>> Clients that make that assumption are broken.  The creation of such clients 
>>> should not be encouraged.
>> 
>> That's your opinion.
> 
> 
> Those opinions are founded upon 30+ years of experience with ARPAnet/Internet 
> protocols in general, and upon my experience as the inventor of IMAP in 
> particular.

That doesn't impress me. Your IMAP server is the weakest server of any of them. 
WU-IMAP is totally stuck in the past. I don't know why you are even part of 
this discussion because you're against any progress. Note the title of this 
thread "Thinking outside the box" - you are the box!

> 
> Maybe it is the case that that plus $4.32 is worth a quad latte in a
> Seattle Starbucks; but I tend to think that the opinions of individuals with 
> decades of experience should be considered and not airily dismissed.

Decades of experience are meaningless when people who have been in it for far 
less time have surpassed you. Your IMAP server quite frankly sucks. 
> 
>> Some people want the simplicity of allowing people who have read access to 
>> use the same connection to send. Just because you don't want to do it 
>> doesn't mean others are like you.
> 
> 
> Just because it would greatly simplify my life to be Dictator Of The World 
> does not mean that I should be elevated to that office.  In fact, it would be 
> a very bad idea.

Agreed.

> 
> Sometimes, it is necessary to accept being told "no".

And - you have the authority to do that? I thought this was a discussion list 
but you seem to want to be the gig dog and tell everyone what they can and 
can't suggest.

> 
> Sometimes, it is necessary to recognize that "no" is the correct answer even 
> if it involves personal inconvenience.

My answer to that is - no!

> 
> Everybody would like to have what is simple for them in all things.  But 
> often it is necessary to make concessions.  It is necessary to consider not 
> only what is good for oneself, but what is good for others.  Even more 
> importantly, it is necessary to consider that what is good for oneself may 
> wreak harm upon others.

I don't know if you've noticed but the only people who are using your IMAP 
server are people who haven't managed to move away from it yet. That's because 
they do want convience.

> 
>>> Your "simplicity" involves considerable costs to others.
>> 
>> What cost? Those who don't want to use it mearly don't use it? The 
>> capability is optional for those who want to implement it.
> 
> 
> There is no such thing as an "option".

Not on your server - everyone else has configuration files.

> 
> If an "option" is widely used, it becomes de facto mandatory.  If an "option" 
> is not widely used, it languishes in obscurity and dies.

Your server is already dead. You're holding everyone else back.

> 
>> It isn't a separate independent mecanism - it's a pass through to your 
>> existing submission server.
> 
> 
> What existing submission server?!?

Any one you set it for. On the server side you woulf have a configuration file 
that said what server and ports to connect to. Generally it would be port 25 
and localhost.

> 
> What makes you think that I have a submission server?  Maybe the system 
> manager who uses my IMAP server also has a submission server someplace, but I 
> don't know anything about it.

That's your problem.

> 
> Maybe you want me to write TCP I/O routines and an SUBMISSION/SMTP engine in 
> my IMAP server to talk to this server.  An SUBMISSION/SMTP client engine is 
> not a trivial undertaking.

Definitely not.

> 
> Do you think that all that has to be done is just pipe bytes (your repeated 
> reference to a "tunnel")?  This is a common novice mistake.

If you are running smtp on the same box then you would connect to localhost. If 
you don't have an smtp server then you can't use the feature.

>
>>>  . IMAP server system administrators are forever doomed to support
>>>    submission on a read-only server system?
>> 
>> Why are you assuming that? You wouldn't activate this feature on a read only 
>> server.
> 
> 
> Then the client that requires that this feature be present, since it does not 
> implement message posting any other way, will fail on that system.

The client could still configure for SMTP as it does now if the feature isn't 
present.

> 
>> This is a slight enhancement of the existing posting mecanism. once the 
>> initial handshake establishes a connection it talks using the existing 
>> protocols.
> 
> 
> Proxies are quite complex by themselves, and proxies embedded inside other 
> protocols (which is what you propose) are even more complex.

Now you're just being silly.

> 
> 
> To start with, you have to recognize that IMAP, not TCP, is now the transport 
> mechanism in SMTP-over-IMAP.  This means that all the TCP conditions which 
> can occur in an SMTP session must now be represented in the IMAP session. 
> This is necessary to distinguish between TCP conditions which occur in the 
> IMAP to SMTP path from TCP conditions that occur in the client to IMAP path. 
> This involves the creation of an escape mechanism. This in turn involves the 
> creation of a quoting mechanism.

You clearly don't understand what I'm suggesting.

> 
> Next, we have to have some mechanism by which the authentication and 
> authorization credentials are passed from the IMAP server to the SMTP server. 
> The very simplest means (and it's not so simple) is to have some out-of-band 
> transmission along with a SASL AUTH EXTERNAL negotation. [No, you can't just 
> validate IP address; all the kewl d00dz have known how to crack that 
> "security" for years now.]

Nope - you don't pass the credentials from IMAP to SMTP. The idea is that if 
you are already authenticated by IMAP then to connect to SMTP without and 
authentication. If you actually READ what I proposed you could talk about it 
accurately. The reason to use this is bacause you are eliminating the need for 
SMTP AUTH.

> 
> We're still talking about embedding one protocol inside another.  We haven't 
> even gotten to the problems faced by a proxy yet.

No - we aren't.

>
>>>  . the Lemonade working group must shelve its other important work
>>>    in order re-open an already-settled debate?
>> 
>> I have no idea why you say this. My suggestion is in addition to what is 
>> proposed.
> 
> 
> Do you honestly believe that you are the very first person ever to have come 
> up with this idea?

perhaps ...

> 
> Do you honestly believe that everybody else is so stupid that they never 
> thought about it?

you don't even grasp the proposal so it's clearly above your head.

> 
> Do you honestly believe that I am so stupid that I didn't think about it when 
> I first invented IMAP?

yep - you are really so full of yourself aren't you.

> 
> Please read the archives of the mailing list.  This idea monopolized the 
> working group's attention for a considerable period of time (more than a 
> year).
> 
>> It might come as a shock to you but out in the real world convienence is 
>> everything. When non-geek users have half the configuration to deal with 
>> that is significant in that it cuts support.
> 
> 
> The membership of this working group contains many individuals from very 
> large and important vendors and extremely diverse backgrounds who are very 
> aware of real world issues.

Some are - some aren't.

> 
> There are many real world issues that this working group needs to address of 
> much greater consequence than your convenience.

If your not looking for convience then why are we trying to create a standard 
for IMAP sending email?

> 
>>> It is so a new protocol.  It involves a massive change to IMAP's protocol 
>>> engine; effectively, IMAP must have two protocol engines.
>> 
>> No - it's a pass through. Once you authenticate it's a tunnel. It is NOT a 
>> new protocol.
> 
> 
> It can't be a tunnel, at least not a tunnel by any definition that I am aware 
> of, and I've been writing tunnels since 1978.
> 
> Your proposal is for a proxy, and more importantly a proxy embedded in 
> another protocol.

My proposal is to open a separate connection to the IMAP server - authenticate 
to it - send a SMTP-TUNNEL command - and then the IMAP server open a port 25 
connection to localhost and passes to to the client over the IMAP port. The 
client then acts like it is talking to an SMTP server over port 143.

> 
>> You know Mark there's something called a configuration file. Ever other IMAP 
>> server developer except you uses one. In a configuration file you can choose 
>> if you are going to offer this feature or not or maybe allow it for some 
>> users and not others.
> 
> 
> Apparently you feel that is a flaw in my server.

One of the happiest days this year was when I got Timo over at Dovecot to add a 
few features I needed to get rid of your IMAP server. Your server really sucks. 
Now I can talk to MySQL if I want to, I can use MAILDIR if I want to. I am free 
of the WU-IMAP cage.

Free at last! Free at last! Free at last!

You're as stubborn and arrogant as Richard Stallman.

_______________________________________________
lemonade mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/lemonade

_______________________________________________
lemonade mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/lemonade

---

From: Marc Perkel <[email-masked]>
Date: Thu, 18 Aug 2005 16:16:49 -0700

I just made a suggestion. If you don't like it - that's fine. But if you 
want to be efficient why don't you just let Mark write the standard 
because it's clear that he's going to shout down everyone else and get 
his way eventually. Why should we waste out time emulating a discussion?